if (not HydraUIGlobal) then
	return
end

local KeyBinding, Popup, Move, Commands, General = HydraUIGlobal:get()
local HydraUI, GUI, Language, Assets, Settings, Defaults = HydraUIGlobal:get()
local Plugin = HydraUI:NewPlugin("HydraUI_Button")
-- Plugin definition is needed to be detected as a plugin in HydraUI :)

local LDB = LibStub("LibDataBroker-1.1", true)
local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)

local OnAccept = function()
	HydraUI:ToggleMovers()
	GUI:Toggle()
end

local OnCancel = function()
	HydraUI:ToggleMovers()
end

if (IsAddOnLoaded("Gathering")) and (IsAddOnLoaded("CalltoArms")) then
 	loadGathCTA = "true"
elseif 	(IsAddOnLoaded("Gathering")) then
	loadGathering = "true"
elseif (IsAddOnLoaded("CalltoArms")) then
	loadCTA = "true"
end


if LDB then

	local HydraUIButton = LDB:NewDataObject("HydraUIButton", {

		type = "launcher",
		icon = "Interface\\AddOns\\HydraUI_Button\\assets\\logo.tga",
		tocname = "HydraUI_Button",

		OnClick = function(clickedframe, button)

			local alt_key = IsAltKeyDown()
			local shift_key = IsShiftKeyDown()
			local control_key = IsControlKeyDown()

			if UnitAffectingCombat("player") == false then

				if button == "LeftButton" then 
					
					if shift_key then

						HydraUI:GetModule("Key Binding"):Toggle()

					elseif control_key then

						if  loadGathering == "true" or loadGathCTA == "true" then

							if  _G["Gathering Header"]:IsVisible() then

								_G["Gathering Header"]:Hide()

							else

								_G["Gathering Header"]:Show()

							end

						end

					elseif alt_key then

						if loadCTA == "true" or loadGathCTA == "true" then

							CallToArmsGlobal:Toggle()

						end

					else

						GUI:Toggle()

					end

				elseif button == "RightButton" then 

					if control_key then

						if  loadGathering == "true" or loadGathCTA == "true" then

							DEFAULT_CHAT_FRAME.editBox:SetText("/gathering") ChatEdit_SendText(DEFAULT_CHAT_FRAME.editBox, 0)
						
						end

					elseif alt_key then

						if loadCTA == "true" or loadGathCTA == "true" then

							DEFAULT_CHAT_FRAME.editBox:SetText("/CTA") ChatEdit_SendText(DEFAULT_CHAT_FRAME.editBox, 0)

						end

					else

						HydraUI:ToggleMovers()
						HydraUI:DisplayPopup(Language["Attention"], Language["Would you like to reopen the settings window?"], Language["Accept"], OnAccept, Language["Cancel"], OnCancel) -- PopupOnCancel
					
					end

				elseif button == "MiddleButton" then 

				end

			else

				print("Cannot do that while in combat.")

			end
		end,

		OnTooltipShow = function(tt)

			tt:AddLine("|cFFFFC44DHydraUI|r Button")
			tt:AddLine("Left-Click |cff44ff44Open the Menu", cs, ce)
			tt:AddLine("Shift + Left-Click |cff44ff44Enable KeyBind Mode", cs, ce)
			tt:AddLine("Right-Click |cff44ff44Enable Move Mode", cs, ce)

			if loadGathCTA == "true" then
				tt:AddLine(" ")
				tt:AddLine("|cFFFFC44DGathering|r")
				tt:AddLine("CTRL-Click |cff44ff44Toggle Gathering Timer", cs, ce)
				tt:AddLine("CTRL-Right-Click |cff44ff44Toggle Gathering Settings", cs, ce)
				tt:AddLine(" ")	
				tt:AddLine("|cFFFFC44DCall To Arms|r")
				tt:AddLine("ALT-Click |cff44ff44Toggle CTA Window", cs, ce)
				tt:AddLine("ALT-Right-Click |cff44ff44Toggle CTA Settings", cs, ce)
			elseif loadGathering == "true" then
				tt:AddLine(" ")
				tt:AddLine("|cFFFFC44DGathering|r")
				tt:AddLine("CTRL-Click |cff44ff44Toggle Gathering Timer", cs, ce)
				tt:AddLine("CTRL-Right-Click |cff44ff44Toggle Gathering Settings", cs, ce)
			elseif loadCTA == "true" then
				tt:AddLine(" ")
				tt:AddLine("|cFFFFC44DCall To Arms|r")
				tt:AddLine("ALT-Click |cff44ff44Toggle CTA Window", cs, ce)
				tt:AddLine("ALT-Right-Click |cff44ff44Toggle CTA Settings", cs, ce)	
			end

			tt:Show()

		end,
	})
	
	if LDBIcon then

		LDBIcon:Register("HydraUIButton", HydraUIButton, HydraUIButton.MinimapIcon)

	end
end